
{

   Unit AIBUS pracuje s komunikacnim portem, u ktereho je smer
   prenosu dat rizen signaly DTR a RTS ( napr. TEDIA PCI-585, apod.).


}


Unit AIBUS;



interface

uses Crt;

var

  Baze,Baze_PCI         : word;
  Rychlost,Dob          : longint;
  ERROR_Time,ERROR_Buff : boolean;
  Adresa                : byte;
  Karta_PCI_052         : boolean;
  ERROR_PCI_052         : boolean;


const

  ParitaVysilani='S';
  ParitaPrijmu='L';

  COM1=$03f8;
  COM2=$02f8;
  COM3=$03e8;
  COM4=$02e8;



Procedure Nastaveni_portu(Baze:word;Rychlost:longint;Parita:char);


{
  Baze        - komunikacni port
  ADRESA      - adresa modulu
  FCE         - pozadovana funkce
  PP_SR       - primy prikaz resp. STATUSn registr
  PERIF       - pozadovana periferie
  B1,B2,B3,B4 - 4x8 bitu vyslanych resp. prijatych dat
  Odpoved     - prijata zprava
}


Function  AIBUS2(Baze:word;ADRESA,FCE,PERIF:byte;var PP_SR,B1,B2,B3,B4:byte;
                 var Odpoved:string):boolean;



implementation


{---------------------------------------------------- Nastaveni_portu -------}

{ 8bit, 1stopbit, parita }

Procedure Nastaveni_portu(Baze:word;Rychlost:longint;Parita:char);

var
  I,Pom,Pocet : byte;
  WI          : longint;


function KodBd(R:longint):byte;
begin
  case (R div 100) of
      6 : KodBd:=0;
     12 : KodBd:=1;
     24 : KodBd:=2;
     48 : KodBd:=3;
     96 : KodBd:=4;
    192 : KodBd:=5;
    384 : KodBd:=6;
    576 : KodBd:=7;
   1152 : KodBd:=8;
     else   KodBd:=4;
  end;
end;


begin
  ERROR_PCI_052:=false;
  if Karta_PCI_052 then
    begin
      port[Baze_PCI+3]:=0;       { uP = RESET }
      Delay(20);
      port[Baze_PCI+3]:=1;       { uP = START }

      port[Baze_PCI+1]:=254;

      Pocet:=0;
      repeat                     { cekani na konec konfigurace }
        Delay(2);
        inc(Pocet);
      until Keypressed or (port[Baze_PCI]=0) or (Pocet>250);
      if Pocet>250 then ERROR_PCI_052:=true;

      port[Baze_PCI+1]:=255;
      port[Baze_PCI]:=1;         { REZIM = 1  }

      port[Baze_PCI+1]:=253;     { Bd rychlost }
      port[Baze_PCI]:=KodBd(Rychlost);

      port[Baze_PCI+1]:=252;     { Timeout }
      port[Baze_PCI]:=250;
    end
   else
    begin
      for I:=0 to 6 do Pom:=port[Baze+I];
      port[Baze+3]:=$80;                      { DLAB }

      WI:=trunc(18432/(Rychlost/100*16));
      port[Baze]:=Lo(WI);
      port[Baze+1]:=Hi(WI);

      Dob:=20000-trunc(Rychlost*5/6);
      if Dob>20000 then Dob:=20000;
      if Dob<5000 then Dob:=5000;

      case Parita of
       'S': port[Baze+3]:=$1B;                {suda,  1 stopbit, 8 bitu}
       'L': port[Baze+3]:=$0B;                {licha, 1 stopbit, 8 bitu}
      end;

      port[Baze+1]:=0;                        { INT zakazan }
      port[Baze+4]:=0;                        { DTR a RTS }
      Pom:=port[Baze];
    end;
end;

{---------------------------------------------------- Vysli_byte ------------}

Procedure Vysli_byte(Baze:word;Znak:byte);
begin
  while((port[Baze+5] and $20)=0) do;
  while((port[Baze+5] and $40)=0) do;
  port[Baze]:=Znak;
  while((port[Baze+5] and $20)=0) do;
  while((port[Baze+5] and $40)=0) do;
end;

{---------------------------------------------------- Prijmi_byte -----------}

Procedure Prijmi_byte(Baze:word;var Znak:byte; var Err:boolean);

var
  Cis : longint;

begin
  Err:=true;
  Cis:=0;
  Znak:=0;
  repeat
    inc(Cis);
    if (port[Baze+5] and $05)=1 then
      begin
        Znak:=port[Baze];
        Err:=false;
      end;
  until (not Err) or (Cis>=Dob);
end;

{---------------------------------------------------- Vypocet CRC -----------}

Procedure Vypocet_CRC(Zprava:string;var CRC:word);

var
  I,J    : byte;
  Prenos : word;

begin
  CRC:=$FFFF;
  for I:=1 to Length(Zprava) do
    begin
      CRC:=CRC xor word(Zprava[I]);
      for J:=1 to 8 do
        begin
          Prenos:=CRC and 1;
          CRC:=CRC shr 1;
          if Prenos=1 then CRC:=CRC xor $A001;
        end;
    end;
end;

{---------------------------------------------------- Zapis_COM -------------}

Procedure Zapis_COM(Baze:word;Zprava_COM:string);

var
  I,Sum : byte;
  CRC   : word;

begin
  Sum:=0;
  Vypocet_CRC(Zprava_COM,CRC);
  Zprava_COM:=Zprava_COM+chr(Lo(CRC))+chr(Hi(CRC));
  for I:=1 to Length(Zprava_COM) do Vysli_byte(Baze,byte(Zprava_COM[I]));
end;

{---------------------------------------------------- Test_SUMA -------------}

Function Test_CRC(Z:string):boolean;

var
  I         : byte;
  CRC1,CRC2 : word;

begin
  Vypocet_CRC(copy(Z,1,8),CRC1);
  CRC2:=byte(Z[10])*256+byte(Z[9]);
  Test_CRC:= CRC1=CRC2;
end;

{---------------------------------------------------- Cti_COM ---------------}

Procedure Cti_COM(Baze:word;var Zprava_COM:string;var ErrBuffEmpty,ErrTimeOut:boolean);

const
  MaxCekani=55;             { casova smycka cekani na prijem odpovedi }

var
  Znak,Sum,Pocet : byte;

begin
  ErrBuffEmpty:=true;
  ErrTimeOut:=true;
  Zprava_COM:='';

  Pocet:=0;
  repeat
    Prijmi_byte(Baze,Znak,ErrTimeOut);
    inc(Pocet);
  until ErrTimeOut or (Znak=Adresa) or (Pocet>MaxCekani);
  if not ErrTimeOut then
    Zprava_COM:=Zprava_COM+chr(Znak);
  Pocet:=0;
  repeat
    Prijmi_byte(Baze,Znak,ErrTimeOut);
    if not ErrTimeOut then
      Zprava_COM:=Zprava_COM+chr(Znak);
    inc(Pocet);
  until ErrTimeOut or (Pocet>MaxCekani);
  if Zprava_COM<>'' then ErrBuffEmpty:=false;
end;



{---------------------------------------------------- AIBUS2 ----------------}

Function  AIBUS2(Baze:word;ADRESA,FCE,PERIF:byte;var PP_SR,B1,B2,B3,B4:byte;
                 var Odpoved:string):boolean;

const
  PocetPokusu = 3;

var
  Err,Err1        : boolean;
  Dotaz,PrvniZnak : string;
  I,Pokus,Pocet   : byte;

begin
  ERROR_PCI_052:=false;
  if Karta_PCI_052 then
    begin
      Pokus:=1;
      repeat
        port[Baze_PCI+1]:=0;
        port[Baze_PCI]:=Adresa;
        port[Baze_PCI+1]:=1;
        port[Baze_PCI]:=FCE;
        port[Baze_PCI+1]:=2;
        port[Baze_PCI]:=PERIF;
        port[Baze_PCI+1]:=3;
        port[Baze_PCI]:=PP_SR;
        port[Baze_PCI+1]:=4;
        port[Baze_PCI]:=B1;
        port[Baze_PCI+1]:=5;
        port[Baze_PCI]:=B2;
        port[Baze_PCI+1]:=6;
        port[Baze_PCI]:=B3;
        port[Baze_PCI+1]:=7;
        port[Baze_PCI]:=B4;

        port[Baze_PCI+1]:=254;     { POVEL }
        port[Baze_PCI]:=1;

        Pocet:=0;
        repeat                     { cekani na konec konfigurace }
          Delay(2);
          inc(Pocet);
        until Keypressed or (port[Baze_PCI]=0) or (Pocet>250);
        if Pocet>250 then ERROR_PCI_052:=true;

        I:=port[Baze_PCI+2];       { mazani priznaku preruseni }

        port[Baze_PCI+1]:=11;
        PP_SR:=port[Baze_PCI];
        port[Baze_PCI+1]:=12;
        B1:=port[Baze_PCI];
        port[Baze_PCI+1]:=13;
        B2:=port[Baze_PCI];
        port[Baze_PCI+1]:=14;
        B3:=port[Baze_PCI];
        port[Baze_PCI+1]:=15;
        B4:=port[Baze_PCI];
        Odpoved:=chr(B1)+chr(B2)+chr(B3)+chr(B4);

        port[Baze_PCI+1]:=31;
        I:=port[Baze_PCI];
        inc(Pokus);
      until ((I=0)or (Pokus>PocetPokusu));
      if I=0 then AIBUS2:=true else AIBUS2:=false;
    end
   else
    begin
      Pokus:=1;
      repeat
        Err:=true;
        port[Baze+4]:=3;                              { prepnuti linky na vysilani }
        Dotaz:=chr(ADRESA)+chr(FCE)+chr(PERIF)+
               chr(PP_SR)+chr(B1)+chr(B2)+chr(B3)+chr(B4);
        Zapis_COM(Baze,Dotaz);
        port[Baze+4]:=0;                              { prepnuti linky na prijem   }
        Cti_COM(Baze,Odpoved,ERROR_Buff,ERROR_Time);
        PrvniZnak:=copy(Odpoved,1,1);
        if (PrvniZnak=chr(Adresa)) then Err:=false;
        Err1:=not (Err or ERROR_Buff or not Test_CRC(Odpoved));
        inc(Pokus);
      until Err1 or (Pokus>PocetPokusu);

      AIBUS2:=Err1;
      PP_SR:=byte(Odpoved[4]);
      B1:=byte(Odpoved[5]);
      B2:=byte(Odpoved[6]);
      B3:=byte(Odpoved[7]);
      B4:=byte(Odpoved[8]);
      Odpoved:=copy(Odpoved,5,4);
    end;
end;







end.
